import { KnapsackRendererBase } from '@knapsack/app';
import type { KnapsackTemplateRenderer as Renderer } from '@knapsack/app/types';
import Hbs from 'handlebars';
export declare class KnapsackHbsRenderer extends KnapsackRendererBase implements Renderer {
    handlebars: typeof Hbs;
    alterHandlebars: (handlebars: typeof Hbs) => void;
    constructor({ alterHandlebars, }?: {
        /**
         * Use this to add custom Handlebars helpers or partials
         * @param handlebars Handlebars instance - https://handlebarsjs.com/api-reference/runtime.html
         */
        alterHandlebars?: typeof KnapsackHbsRenderer.prototype.alterHandlebars;
    });
    registerComponentPaths(): Promise<void>;
    init(options: Parameters<Renderer['init']>[0]): ReturnType<Renderer['init']>;
    onChange(): ReturnType<Renderer['onChange']>;
    render(opt: Parameters<Renderer['render']>[0]): ReturnType<Renderer['render']>;
    getUsage({ pattern, patternManifest, template, demo, }: Parameters<Renderer['getUsage']>[0]): ReturnType<Renderer['getUsage']>;
    getTemplateSuggestions(): ReturnType<Renderer['getTemplateSuggestions']>;
    getMeta: Renderer['getMeta'];
}
//# sourceMappingURL=renderer-hbs.d.ts.map