"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getHbsUsage = exports.splitData = void 0;
/**
 * @todo add description why this is necessary
 * https://linear.app/knapsack/issue/KSP-2184/handlebars-renderer-does-not-handle-arrays-correctly-cnn-blocker
 * https://www.notion.so/knapsackcloud/Handlebars-Nested-Data-7ef0271a79294083b986355067c8b491
 */
function splitData(data) {
    return Object.entries(data || {}).reduce((cur, [key, value]) => {
        switch (typeof value) {
            case 'boolean':
            case 'string':
            case 'number':
                cur.paramData[key] = value;
                break;
            default:
                cur.globalData[key] = value;
        }
        return cur;
    }, {
        globalData: {},
        paramData: {},
    });
}
exports.splitData = splitData;
async function getHbsUsage({ templateName, data, slots, }) {
    const { paramData } = splitData(data);
    const props = Object.keys(paramData).map((key) => {
        const value = JSON.stringify(data[key]);
        return `${key}=${value}`;
    });
    if (!slots) {
        return [`{{> ${templateName}`, ...props, '}}'].join(' ');
    }
    // Slots return here
    const start = [`{{#> ${templateName}`, ...props, '}}'].join(' ');
    const finish = `{{/${templateName}}}`;
    return [
        start,
        ...slots.map(({ name, content }) => {
            return [
                `  {{#*inline "${name}"}}`,
                content.map((c) => `    ${c}`).join('\n'),
                '  {{/inline}}',
            ].join('\n');
        }),
        finish,
    ].join('\n');
}
exports.getHbsUsage = getHbsUsage;
//# sourceMappingURL=utils.js.map